<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description" content="Learn how to integrate TinyMCE 6 and elFinder 2.1.65 to provide for seamless file management. And save the content that is created.">
<meta name="keywords" content="TinyMCE, elFinder">
<title>TinyMCE 6 and elFinder Integration</title>
<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.min.css"/>
<style>
.leftside {
width: 20%; }

.rightside {
width: 60%; }

@media (max-width: 1000px) {
.leftside, .rightside {
width: 100%;
float: left; }}
</style>
<link rel="stylesheet" href="css/style.css">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.min.css"/>
<script type="text/javascript" src="https://studio-42.github.io/elFinder/demo/js/elfinder.min.js"></script>
<script type="text/javascript" src="https://nao-pon.github.io/tinymceElfinder/tinymceElfinder.js"></script>


<?php
/**
 * 
 * Integrate elFinder with TinyMCE
 * 
 * 
 */ ?>

<script>
const mceElf = new tinymceElfinder({
url: 'elFinder/php/connector.minimal.php',
uploadTargetHash: 'l1_lw',
nodeId: 'elfinder'
});
</script>

<script src="tinymce/tinymce.min.js"></script>
<script>
tinymce.init({
selector: '#editor',

plugins: 'image fullscreen source advsource advlink table link emoticons code codesample media preview wordcount importcss autoresize textcolor loremipsum',

file_picker_callback : mceElf.browser,
images_upload_handler: mceElf.uploadHandler,

menubar: 'file edit view insert format tools table help',

toolbar1: 'cut copy code | undo redo | alignleft aligncenter alignright alignjustify outdent indent | fullscreen',
toolbar2: 'link | hr | emoticons | fontsize fontfamily | bold italic underline strikethrough | forecolor backcolor | preview | styleselect blockquote | print | loremipsum | image | media | table',

default_link_target: '_blank',

promotion: false,

min_height: 600,
max_height: 600,
});
</script>
</head>
<body>

<div class="overall-container">
<div class="content-container">
<h1 class="center coltitlecolor">TinyMCE 6.8.2 and elFinder 2.1.65 Integration</h1>

<table><tr><td class="leftside">
<ul class="left gentextcolor">File Structure:
<li> <i style="color:#ffff00; font-size:22px;" class="fa fa-folder"></i> assets</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file"></i> index.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> builder.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> config.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> save_content.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> update.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> edit.php</li>
<li> --<i style="color:#fff; font-size:14px;" class="fa fa-file""></i> functions.php</li>
<li> -- <i style="color:#ffff00; font-size:22px;" class="fa fa-folder"></i> css</li>
<li> ---- <i style="color:#fff; font-size:14px;" class="fa fa-file""></i> style.css</li>
<li> -- <i style="color:#ffff00; font-size:22px;" class="fa fa-folder"></i> images</li>
<li> -- <i style="color:#ffff00; font-size:22px;" class="fa fa-folder"></i> tinymce</li>
<li> -- <i style="color:#ffff00; font-size:22px;" class="fa fa-folder"></i> elFinder</li>

</ul>
</td><td class="rightside">
<p class="left"><a href="index.php" target="_blank" class="button">See Home Page in Action</a></p>

<p class="left">If you only need to add the editor into a project you already have <a href="editor.zip" class="button" download>then download this</a>.</p>

<h3 class="left">In this tutorial I am going to show you how to integrate elFinder for full file management into the TinyMCE editor for seamless operation.<br>At the end we will be able to upload and manage images and other files using the elFinder interface. And also be able to save our work to a database.<br>I am assuming that you have already downloaded <a href="https://www.tiny.cloud/get-tiny/" target="_blank">TinyMCE 6.8.2</a> and <a href="https://github.com/Studio-42/elFinder/releases/tag/2.1.65" target=_blank">elFinder 2.1.65</a>.</h3>

<h3 class="left">
&bull; Create a folder and name it assets to house the files and folders.
<br>&bull; Open the assets folder and create a file named builder.php
<br>&bull; Copy/paste the following code into builder.php
<br><br>This is the correct path to the image folder if TinyMCE and elFinder are in the same folder.</h3>
</td></tr></table>

<p class="center">The source files and/or a complete package can be downloaded at the bottom of this tutorial.</p>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="30">
&lt;?php 
require_once 'config.php';
require_once 'save_content.php'; 

if (isset($_GET['edit'])) {
$id = $_GET['edit'];
$update = true;
$record = mysqli_query($db, "SELECT * FROM articles id='$id'"); {
$n = mysqli_fetch_array($record);
$title = $n['title'];
$content = $n['content']; }} ?&gt;

<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description" content="TinyMCE 6 and elFinder Integration">
<meta name="keywords" content="TinyMCE, elFinder">
<title>TinyMCE 6 and elFinder 2.1.65 Integration</title>
<link rel="stylesheet" href="css/style.css"/>
<!-- Theme that elFinder will use -->
<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.min.css"/>
<!-- jQuery and jQuery-UI -->
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<!-- elFinder (load latest nightly) -->
<script type="text/javascript" src="https://studio-42.github.io/elFinder/demo/js/elfinder.min.js"></script>
<!-- tinymceElfinder -->
<script type="text/javascript" src="https://nao-pon.github.io/tinymceElfinder/tinymceElfinder.js"></script>

&lt;?php
/**
* 
* Integrate elFinder with TinyMCE
* 
* 
*/ ?&gt;

<script>
const mceElf = new tinymceElfinder({
url: 'elFinder/php/connector.minimal.php',
uploadTargetHash: 'l1_lw',
nodeId: 'elfinder'
});
</script>

<script src="tinymce/tinymce.min.js"></script>
<script>
tinymce.init({
selector: '#editor',

plugins: 'image fullscreen source advsource advlink table link emoticons code codesample media preview wordcount importcss autoresize textcolor loremipsum',

file_picker_callback : mceElf.browser,
images_upload_handler: mceElf.uploadHandler,

menubar: 'file edit view insert format tools table help',

toolbar1: 'cut copy code | undo redo | alignleft aligncenter alignright alignjustify outdent indent | fullscreen',
toolbar2: 'link | hr | emoticons | fontsize fontfamily | bold italic underline strikethrough | forecolor backcolor | preview | styleselect blockquote | print | loremipsum | image | media | table',

default_link_target: '_blank',
promotion: false,
min_height: 600,
});
</script>
</head>
<body>
<h1 class="center title">Article Builder</h1>
<?php require_once 'menu.php'; ?>
<div><a href="edit.php" class="button">Edit Articles</a></div>

<div id="wrapper">

&lt;?php $results = mysqli_query($db, "SELECT * FROM articles"); ?&gt;

<form method="post" action="save_content.php" target="_blank">

<input type="hidden" name="id" value="&lt;?= $id; ?&gt;">

<p class="center" style="color:#ffffff">Enter Title:<br>
<input name="title" value="&lt;?= $title ?&gt;" class="spacer" style="width:300px">
</p>

&lt;textarea name="content" id="editor"&gt;&lt;?= $content ?&gt;&lt;/textarea&gt;
&lt;?php updatepublish(); ?&gt;

</form>
</div>
<div id="wrapper">
<?php require_once 'footer.php'; ?>
</div>
</body>
</html>
</textarea>

<h3 class="center">In the elFinder folder go to php/connector.minimal.php-dist and rename the file connector.minimal.php</h3>
<h3 class="center">Open the file and look for the following. Change the path and URL to point to the images folder, as I have in the example below.</h3>


<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="30">
array(
'driver'        => 'LocalFileSystem',           // driver for accessing file system (REQUIRED)
'path'          => '../../images/',                 // path to files (REQUIRED)
'URL'           => dirname($_SERVER['PHP_SELF']) . '/../../images/', // URL to files (REQUIRED)
'trashHash'     => 't1_Lw',                     // elFinder's hash of trash folder
'winHashFix'    => DIRECTORY_SEPARATOR !== '/', // to make hash same to Linux one on windows too
'uploadDeny'    => array(''),                // All Mimetypes not allowed to upload
'uploadAllow'   => array('all'), // Mimetype `image` and `text/plain` allowed to upload
'uploadOrder'   => array('deny', 'allow'),      // allowed Mimetype `image` and `text/plain` only
'accessControl' => 'access'                     // disable and hide dot starting files (OPTIONAL)
),
// Trash volume
array(
'id'            => '1',
'driver'        => 'Trash',
'path'          => '../../images/.trash/',
'tmbURL'        => dirname($_SERVER['PHP_SELF']) . '/../../images/.trash/.tmb/',
'winHashFix'    => DIRECTORY_SEPARATOR !== '/', // to make hash same to Linux one on windows too
'uploadDeny'    => array(''),                // Recommend the same settings as the original volume that uses the trash
'uploadAllow'   => array('all'), // Same as above
'uploadOrder'   => array('deny', 'allow'),      // Same as above
'accessControl' => 'access',                    // Same as above
</textarea>

<br>

<h3 class="center">Let's create a simple MySQL table to store the articles that you create.
<br>On your server go to PhpMyAdmin and create a database.
<br>Then copy/paste the following into the new database.
<br>The AUTO_INCREMENT allows for you to build an unlimited number of articles.
<br>And each article can be edited by going to the edit.php file.</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="12">
-- --------------------------------------------------------
--
-- Table structure for table `articles`
--
DROP TABLE IF EXISTS `articles`;
CREATE TABLE IF NOT EXISTS `articles` (
`id` int UNSIGNED NOT NULL AUTO_INCREMENT,
`title` tinytext,
`content` blob,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;
</textarea>
<br>

<h3 class="center">
In the assets folder create a new file and name it config.php
<br>Open the file and copy/paste the following.
<br>Change the database credentials to match your database credentials.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="15">
&lt;?php
$servername = "localhost";
$username = "root";
$password = "";
$database = "homepage";

// Create connection
$db = mysqli_connect($servername, $username, $password, $database);
$conn = mysqli_connect($servername, $username, $password, $database);
// Check connection
if (!$db) {
die("Connection failed: " . mysqli_connect_error());
}
</textarea>

<br>

<h3 class="center">
In the assets folder create a new file and name it save_content.php.
<br>Open the file and copy/paste the following.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="40">
&lt;?php require_once 'config.php';

// initialize the variables
$title = "";
$content = "";
$id = 0;
$update = false;

// Create new article 
if (isset($_POST['save'])) {
$title = mysqli_real_escape_string($conn, $_POST['title']);
$content = mysqli_real_escape_string($conn, $_POST['content']);

mysqli_query($db, "INSERT INTO articles (title, content) VALUES ('$title', '$content')");
$_SESSION['message'] = "Article Saved!";
echo "<script> window.location.replace('update.php') </script>"; }

// Update existing article
if (isset($_POST['update'])) {
$id = $_POST['id'];
$title = mysqli_real_escape_string($conn, $_POST['title']);
$content = mysqli_real_escape_string($conn, $_POST['content']);

mysqli_query($db, "UPDATE articles SET title='$title', content='$content WHERE id=$id");
$_SESSION['message'] = "Article Updated!";
echo "<script> window.location.replace('update.php') </script>"; }

// Delete exiting article from the db
if (isset($_GET['del'])) {
$id = $_GET['del'];
mysqli_query($db, "DELETE FROM articles WHERE id=$id");
$_SESSION['message'] = "Article deleted!";
echo "<script> window.location.replace('edit.php') </script>"; }
$results = mysqli_query($db, "SELECT * FROM articles");
</textarea>

<br>

<h3 class="center">
In the assets folder create a new file and name it edit.php
<br>Open the file and copy/paste the following.
<br>This file will let you view, edit, and delete the pages.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="45">
&lt;?php require_once 'config.php'; ?&gt;
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="x-ua-compatible" content="ie=edge">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no" />
<title>All Articles</title>
<link rel="stylesheet" href="style.css"/>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
<h1 class="center title">Article Management</h1>
<?php require_once 'menu.php'; ?>
<div id="wrapper">
<p>&nbsp;</p>
<div class="left">
<a href="builder.php" style="text-decoration:none; width:200px;" class="center button">Add New</a>
</div>
<br>
<div class="row spacer">
&lt;?php 
/**
* 
* Build the array to
* display all articles.
* 
*/
$sql = "SELECT * FROM articles"; 
$result = $conn->query($sql); 
if ($result->num_rows > 0) { 
while ($row = $result->fetch_assoc()) { ?&gt;
<div class="column4">
<div class="content-card">
<h1 class="center title">&lt;?= $row['title'] ?&gt;</h1>
<div class="left" style="background:#ffffff; height:280px; overflow-y:auto;">
<p>ID: &lt;?= $row['id'] ?&gt;</p>
<p>&lt;?= $row['content'] ?&gt;</p>
</div>
<div class="action-card">
<p class="center"><a href="index.php?edit=&lt;?= $row['id'] ?&gt;" onclick="basicPopup(this.href);return false" title="Edit"><i style="color:#ffffff" class="fa fa-edit"></i></a>
&nbsp;&nbsp;&nbsp;
<a href="preview.php?id=&lt;?= $row['id'] ?&gt;" target="_blank" title="Preview"><i style="color:#ffffff" class="fa fa-eye"></i></a>
&nbsp;&nbsp;&nbsp;
<a href="save_content.php?del=&lt;?= $row['id']; ?&gt;" onclick="return confirm('Are You Sure, This Action is Permanent')" title="Delete"><i style="color:#ffffff" class="fa fa-trash"></i></a>
</div></div></div>
&lt;?php }} ?&gt;
</td></tr></table>
</div>
</body>
</html>
</textarea>

<h3 class="center">In the assets folder create a new file and name it functions.php and copy/paste the following into it.
<br>This is the function that will save the content.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>
<textarea class="js-copytextarea" style="width:100%" rows="20">
&lt;?php function update() {
require_once 'update.php'; }

function updatepublish() {
global $update; ?&gt;
<div style="width:100%; background:#223366;">
<div style="z-index:999; padding:10px;" class="center">
&lt;?php if ($update == true) { ?&gt;
<button style="cursor:pointer;" type="submit" class="button" name="update">Update Record</button>
&nbsp;&nbsp;&nbsp;
<button style="cursor:pointer;" class="button"><a href="#" style="text-decoration:none"><span style="color:#fff">Refresh</span></a></button>
&lt;?php } else { ?&gt;
<button style="cursor:pointer;" class="button" type="submit" name="save">Publish</button>
&nbsp;&nbsp;&nbsp;
<button style="cursor:pointer;" class="button"><a href="#" style="text-decoration:none"><span style="color:#fff">Refresh</span></a></button>
&lt;?php } ?&gt;
</div></div>
&lt;?php }
</textarea>

<br>

<h3 class="center">In the assets folder create a new folder and name it css.
<br>Open that css folder and create a new file and name it style.css and copy/paste the following into it.
<br>This is the overall styling.</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="60">
body {
background: #ebebeb;
}

#wrapper {
background: #ffffff;
padding: 20px;
}

.whisp {
padding-top: 8%;
min-height: 260px;
}

#container {
border-radius: 10px;
-moz-border-radius: 10px;
-webkit-border-radius: 10px;
-khtml-border-radius: 10px;
height: 130px;
margin: 0 auto;
position: relative;
width: 356px;
}

#sub-container {
background: #ebebeb;
border: 1px solid #333;
border-color: rgba(0, 0, 0, 0.2);
border-radius: 10px;
-moz-border-radius: 10px;
-webkit-border-radius: 10px;
-khtml-border-radius: 10px;
box-shadow: 0 0 10px #000 inset;
height: 160px;
left: 5px;
position: absolute;
top: 5px;
width: 345px;
}

#sub-header {
background-color: #02435d;
background-color: rgba(2, 67, 93, 0.75);
filter: progid: DXImageTransform.Microsoft.gradient(startColorstr=#c002435d, endColorstr=#c002435d);
border-bottom: 1px solid #002F3F;
border-radius: 5px 5px 0 0;
-moz-border-radius: 5px 5px 0 0;
-webkit-border-radius: 5px 5px 0 0;
-khtml-border-radius: 5px 5px 0 0;
height: 65px;
padding: 10px 0 0;
text-align: center;
color: #fff;
text-shadow: 1px 1px 2px #000;
font-size: 2vw;
}

.center {
text-align: center;
}

.left {
text-align: left;
}

.title {
background: #336699;
padding: 20px;
color: #ffffff;
}

p {
font-size: 18px;
color: #000000;
}

.card7 {
background: #ebebeb;
padding: 20px;
}

.action-card {
height: 50px;
display: flex;
flex-direction: column;
border: 1px solid rgba(255, 255, 255, 0.25);
border-radius: 20px;
background: #223366;
box-shadow: 0 0 10px 1px rgba(0, 0, 0, 0.25);
backdrop-filter: blur(15px);
}

.content-card {
margin: 20px auto;
padding: 14px 24px;
border: 2px solid #FFF;
border-radius: 15px;
box-shadow: 0 0 5px 2px #000000, inset 0 3px 18px rgba(100, 100, 100, 0.25);
width: 87%;
height: 400px;
display: flex;
flex-direction: column;
border: 1px solid #000000;
background: linear-gradient(#336699, #223366);
backdrop-filter: blur(15px);
}

.content-card:hover {
background: #223366;
}

.column4 {
float: left;
width: 25%;
}


/* Remove extra left and right margins, due to padding */

.row {
margin: 0 -5px;
}


/* Clear floats after the columns */

.row:after {
content: "";
display: table;
clear: both;
}

/* Responsive columns */

@media screen and (max-width: 1000px) {
.column4 {
width: 100%;
display: block;
margin-bottom: 20px;
}
}

.spacer {
padding: 12px;
}

.button {
border-top: 2px solid #06d1f8;
background: #65a9d7;
background: -webkit-gradient(linear, left top, left bottom, from(#6e779d), to(#65a9d7));
background: -webkit-linear-gradient(top, #6e779d, #65a9d7);
padding: 5px 10px;
border-radius: 8px;
color: #fff;
font-size: 14px;
font-family: Georgia, serif;
text-decoration: none;
vertical-align: middle;
}
.button:hover {
border-top-color: #28597a;
background: #28597a;
color: #ccc;
}
.button:active {
border-top-color: #1b435e;
background: #1b435e;
}
</textarea>

<br>

<h3 class="center">In the assets folder create a new file and name it index.php
<br>This file will be used to display the articles.
</h3>
<p class="center"><button class="js-textareacopybtn"> Copy </button></p>
<textarea class="js-copytextarea" style="width:100%" rows="30">
&lt;?php require_once 'config.php'; ?&gt;
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="x-ua-compatible" content="ie=edge">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no" />
<title>Home Page CMS</title>
<link rel="stylesheet" href="css/style.css"/>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
<div class="overall-container">
<div class="center title">
<h1>Home Page</h1>
<p style="color:#fff">Content Management System</p>
</div>
<?php require_once 'menu.php'; ?>

&lt;?php $sql = "SELECT * FROM articles"; 
$result = $conn->query($sql); 
if ($result->num_rows > 0) { 
while ($row = $result->fetch_assoc()) { ?&gt;
<!-- Build the array to display the content-->
<div class="content-container">
<h1 class="center">&lt;?= $row['title'] ?&gt;</h1>
<br>
&lt;?= $row['content'] ?&gt;
</div>
&lt;?php }} ?&gt;
</div>
</div>
</body>
</html>
</textarea>

<br>

<h3 class="center">
This is the file that is used to preview the articles.
<br>In the assets folder create a new file and name it preview.php
<br>Copy/paste the follow into it.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="30">
&lt;?php require_once 'config.php'; ?&gt;
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="x-ua-compatible" content="ie=edge">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no" />
<title>Home Page CMS</title>
<link rel="stylesheet" href="css/style.css"/>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
&lt;?php if (isset($_GET['id'])) { $id = $_GET['id'];
$id = mysqli_real_escape_string($conn, $id);} 
$sql = "SELECT * FROM articles WHERE id='$id'"; 
$result = $conn->query($sql); 
if ($result->num_rows > 0) { 
while ($row = $result->fetch_assoc()) { ?&gt;
<div class="content-container">
<h1 class="center title">&lt;?= $row['title'] ?&gt;</h1>
<p>&lt;?= $row['content'] ?&gt;</p>
</div>
&lt;?php }} ?&gt;
<div class="center">
<input type="button" value="Close This Window" onclick="self.close()">
</div>
<script>
function windowClose() { window.open('','_parent','');
window.close(); }
</script>
</textarea>

<br>

<h3 class="center">
In the assets folder create a new file and name it menu.php
<br>
Copy/paste the following into it.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="30">
<link rel="stylesheet" href="css/style.css">
<div class="topnav" id="myTopnav">
<a href="index.php" class="active">Home</a>
<a href="builder.php">Article Builder</a>
<a href="edit.php">Edit Articles</a>
<a href="#contact">Contact</a>
<div class="dropdown">
<button class="dropbtn">Dropdown 
<i class="fa fa-caret-down"></i>
</button>
<div class="dropdown-content">
<a href="#">Link 1</a>
<a href="#">Link 2</a>
<a href="#">Link 3</a>
</div>
</div>
<a href="#about">About</a>
<a href="javascript:void(0);" style="font-size:15px;" class="icon" onclick="myFunction()">&#9776;</a>
</div>

<script>
function myFunction() {
var x = document.getElementById("myTopnav");
if (x.className === "topnav") {
x.className += " responsive";
} else {
x.className = "topnav"; }}
</script>
</textarea>

<h3 class="center">In the assets/css folder open the file style.css
<br>Copy/paste the following into it.
</h3>

<p class="center"><button class="js-textareacopybtn"> Copy </button></p>

<textarea class="js-copytextarea" style="width:100%" rows="30">

/**
* Menu Styling
*/

.topnav {
overflow: hidden;
background: linear-gradient(#336699, #223366);
padding: 10px;
}

.topnav a {
float: left;
display: block;
color: #f2f2f2;
text-align: center;
padding: 14px 16px;
text-decoration: none;
font-size: 17px;
}

.active {
background-color: #223366;
color: white;
}

.topnav .icon {
display: none;
}

.dropdown {
float: left;
overflow: hidden;
}

.dropdown .dropbtn {
font-size: 17px;    
border: none;
outline: none;
color: white;
padding: 14px 16px;
background-color: inherit;
font-family: inherit;
margin: 0;
}

.dropdown-content {
display: none;
position: absolute;
background-color: #f9f9f9;
min-width: 160px;
box-shadow: 0px 8px 16px 0px rgba(0,0,0,0.2);
z-index: 1;
}

.dropdown-content a {
float: none;
color: black;
padding: 12px 16px;
text-decoration: none;
display: block;
text-align: left;
}

.topnav a:hover, .dropdown:hover .dropbtn {
background-color: #223366;
color: white;
}

.dropdown-content a:hover {
background-color: #223366;
color: black;
}

.dropdown:hover .dropdown-content {
display: block;
}

@media screen and (max-width: 600px) {
.topnav a:not(:first-child), .dropdown .dropbtn {
display: none;
}
.topnav a.icon {
float: right;
display: block;
}
}

@media screen and (max-width: 600px) {
.topnav.responsive {position: relative;}
.topnav.responsive .icon {
position: absolute;
right: 0;
top: 0;
}
.topnav.responsive a {
float: none;
display: block;
text-align: left;
}
.topnav.responsive .dropdown {float: none;}
.topnav.responsive .dropdown-content {position: relative;}
.topnav.responsive .dropdown .dropbtn {
display: block;
width: 100%;
text-align: left; }}
</textarea>

<br>

<textarea id="editor"></textarea>

<p class="center">Download TinyMCE 6.8.2 and elFinder 2.1.65. Create a database and add the table and you will have an operational tiny CMS.</p>

<div class="center">
<a href="homepage.zip" class="button" download>Download Complete Package (2.12mb)</a>
</div>

<h3 class="center">
<a href="index.php" target="_blank" class="button">See Home Page in Action</a>
</h3>

<p>&nbsp;</p>

<script>
window.onload = function () {
// Get all the elements that match the selector as arrays
var copyTextareaBtn = Array.prototype.slice.call(document.querySelectorAll('.js-textareacopybtn'));
var copyTextarea = Array.prototype.slice.call(document.querySelectorAll('.js-copytextarea'));
// Loop through the button array and set up event handlers for each element
copyTextareaBtn.forEach(function(btn, idx){
btn.addEventListener("click", function(){
// Get the textarea who's index matches the index of the button
copyTextarea[idx].select();
try {
var msg = document.execCommand('copy') ? 'successful' : 'unsuccessful';
console.log('Copying text command was ' + msg);
} catch (err) {
console.log('Whoops, unable to copy');
} 
});
});
}
</script>
</body>
</html>